
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bsetrack.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bsetrack.hh>
#include <bse/bsepart.hh>
#include <bse/bsesong.hh>
#include <bse/bsebus.hh>
#include <bse/bseundostack.hh>
#include "bsecxxplugin.hh"
/* --- insert-part --- */
static void
insert_part_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 12 "bsetrack.proc"
 {
#line 14 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("tick", "Tick", NULL,
			 0, 0, BSE_PART_MAX_TICK - 1, 384, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = bse_param_spec_object ("part", "Part", NULL,
				 BSE_TYPE_PART, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_int ("id", "Link ID", NULL,
                         0, 0, SFI_MAXINT, 1, SFI_PARAM_STANDARD);
}
#line 23 "bsetrack.proc"
 }
static BseErrorType
#line 23 "bsetrack.proc"
insert_part_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 26 "bsetrack.proc"
{
#line 27 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
  guint tick = sfi_value_get_int (in_values++);
  BsePart *part = (BsePart*) bse_value_get_object (in_values++);
  guint id;
#line 32 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self) || !BSE_IS_PART (part) ||
      !BSE_ITEM (self)->parent ||
      BSE_ITEM (self)->parent != BSE_ITEM (part)->parent)
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 37 "bsetrack.proc"
  
  id = bse_track_insert_part (self, tick, part);
  if (id)
    {
#line 41 "bsetrack.proc"
      
      bse_item_push_undo_proc (self, "remove-tick", tick);
    }
#line 44 "bsetrack.proc"
  
  g_value_set_int (out_values++, id);
  return BSE_ERROR_NONE;
}
/* --- remove-tick --- */
static void
remove_tick_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 48 "bsetrack.proc"
 {
#line 50 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("tick", "Tick", NULL,
			 0, 0, BSE_PART_MAX_TICK - 1, 384, SFI_PARAM_STANDARD);
}
#line 55 "bsetrack.proc"
 }
static BseErrorType
#line 55 "bsetrack.proc"
remove_tick_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 58 "bsetrack.proc"
{
#line 59 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
  guint     tick = sfi_value_get_int (in_values++);
  BseTrackEntry *entry;
#line 63 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 66 "bsetrack.proc"
  
  entry = bse_track_lookup_tick (self, tick);
  if (entry)
    {
      bse_item_push_undo_proc (self, "insert-part", entry->tick, entry->part);
      bse_track_remove_tick (self, tick);
    }
  return BSE_ERROR_NONE;
}
/* --- remove-link --- */
static void
remove_link_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 75 "bsetrack.proc"
 {
#line 77 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("id", "Link ID", NULL,
			 0, 0, SFI_MAXINT, 384, SFI_PARAM_STANDARD);
}
#line 82 "bsetrack.proc"
 }
static BseErrorType
#line 82 "bsetrack.proc"
remove_link_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 85 "bsetrack.proc"
{
#line 86 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
  guint     id   = sfi_value_get_int (in_values++);
  BseTrackEntry *entry;
#line 90 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
  entry = bse_track_find_link (self, id);
  if (!entry)
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 96 "bsetrack.proc"
  
  bse_item_push_undo_proc (self, "insert-part", entry->tick, entry->part);
  bse_track_remove_tick (self, entry->tick);
  return BSE_ERROR_NONE;
}
/* --- list-parts --- */
static void
list_parts_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 101 "bsetrack.proc"
 {
#line 103 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("part_list", "Part List", NULL,
				BSE_TYPE_TRACK_PART_SEQ, SFI_PARAM_STANDARD);
}
#line 108 "bsetrack.proc"
 }
static BseErrorType
#line 108 "bsetrack.proc"
list_parts_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 111 "bsetrack.proc"
{
#line 112 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
#line 114 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 117 "bsetrack.proc"
  
  bse_value_take_boxed (out_values++, bse_track_list_parts (self));
  return BSE_ERROR_NONE;
}
/* --- list-parts-uniq --- */
static void
list_parts_uniq_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 121 "bsetrack.proc"
 {
#line 123 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("part_list", "Part List", NULL,
				BSE_TYPE_ITEM_SEQ, SFI_PARAM_STANDARD); // FIXME: should use BsePartSeq here
}
#line 128 "bsetrack.proc"
 }
static BseErrorType
#line 128 "bsetrack.proc"
list_parts_uniq_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 131 "bsetrack.proc"
{
#line 132 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
#line 134 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 137 "bsetrack.proc"
  
  BseTrackPartSeq *tpseq = bse_track_list_parts (self);
  SfiRing *ring = NULL;
  guint i;
  for (i = 0; i < tpseq->n_tparts; i++)
    ring = sfi_ring_append (ring, tpseq->tparts[i]->part);
  bse_track_part_seq_free (tpseq);
  ring = sfi_ring_sort (ring, sfi_pointer_cmp, NULL);
  ring = sfi_ring_uniq (ring, sfi_pointer_cmp, NULL);
  bse_value_take_boxed (out_values++, bse_item_seq_from_ring (ring));
  sfi_ring_free (ring);
  return BSE_ERROR_NONE;
}
/* --- get-part --- */
static void
get_part_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 150 "bsetrack.proc"
 {
#line 152 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("tick", "Tick", NULL,
			 0, 0, BSE_PART_MAX_TICK - 1, 384, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("part", "Part", NULL,
				 BSE_TYPE_PART, SFI_PARAM_STANDARD);
}
#line 159 "bsetrack.proc"
 }
static BseErrorType
#line 159 "bsetrack.proc"
get_part_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 162 "bsetrack.proc"
{
#line 163 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
  guint     tick = sfi_value_get_int (in_values++);
  BseTrackEntry *entry;
#line 167 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 170 "bsetrack.proc"
  
  entry = bse_track_lookup_tick (self, tick);
  bse_value_set_object (out_values++, entry ? entry->part : NULL);
  return BSE_ERROR_NONE;
}
/* --- get-timing --- */
static void
get_timing_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 175 "bsetrack.proc"
 {
#line 177 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL, BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("tick", "Tick", "Tick to retrieve timing info about", 0, 0, G_MAXINT, 384, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("timing", "Timing", "Song Timing", BSE_TYPE_SONG_TIMING, SFI_PARAM_STANDARD);
#line 180 "bsetrack.proc"
}  }
static BseErrorType
#line 180 "bsetrack.proc"
get_timing_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 183 "bsetrack.proc"
{
#line 184 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
  SfiInt    tick = sfi_value_get_int (in_values++);
  BseItem  *parent;
  BseSongTiming timing = { 0, };
#line 189 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 192 "bsetrack.proc"
  
  parent = BSE_ITEM (self)->parent;
  if (BSE_IS_SONG (parent))
    bse_song_get_timing (BSE_SONG (parent), tick, &timing);
  else
    bse_song_timing_get_default (&timing);
#line 198 "bsetrack.proc"
  
  bse_value_set_boxed (out_values++, &timing);
  return BSE_ERROR_NONE;
}
/* --- get-output-source --- */
static void
get_output_source_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 202 "bsetrack.proc"
 {
#line 205 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", NULL, NULL,
                                 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("source", NULL, NULL,
                                 BSE_TYPE_SOURCE, SFI_PARAM_STANDARD);
#line 209 "bsetrack.proc"
}  }
static BseErrorType
#line 209 "bsetrack.proc"
get_output_source_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 212 "bsetrack.proc"
{
#line 213 "bsetrack.proc"
  
  BseTrack *track = (BseTrack*) bse_value_get_object (in_values++);
  BseSource *child = NULL;
#line 216 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (track))
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 219 "bsetrack.proc"
  
  child = bse_track_get_output (track);
#line 221 "bsetrack.proc"
  
  bse_value_set_object (out_values++, child);
  return BSE_ERROR_NONE;
}
/* --- get-last-tick --- */
static void
get_last_tick_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 225 "bsetrack.proc"
 {
#line 227 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
                                 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_int ("last_tick", "Last Tick", NULL,
                         0, 0, G_MAXINT, 384, SFI_PARAM_STANDARD);
#line 231 "bsetrack.proc"
}  }
static BseErrorType
#line 231 "bsetrack.proc"
get_last_tick_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 234 "bsetrack.proc"
{
#line 235 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
#line 237 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 240 "bsetrack.proc"
  
  sfi_value_set_int (out_values++, bse_track_get_last_tick (self));
  return BSE_ERROR_NONE;
}
/* --- ensure-output --- */
static void
ensure_output_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 244 "bsetrack.proc"
 {
#line 246 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
                                 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", NULL, NULL,
                                BSE_TYPE_ERROR_TYPE, BSE_ERROR_NONE, SFI_PARAM_STANDARD);
#line 250 "bsetrack.proc"
}  }
static BseErrorType
#line 250 "bsetrack.proc"
ensure_output_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 253 "bsetrack.proc"
{
#line 254 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
  BseErrorType error = BSE_ERROR_NONE;
#line 257 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
#line 260 "bsetrack.proc"
  
  BseItem *parent = BSE_ITEM (self)->parent;
  if (BSE_IS_SONG (parent) && !self->bus_outputs)
    {
      BseSong *song = BSE_SONG (parent);
      BseBus *master = bse_song_find_master (song);
      if (master)
        {
          error = bse_bus_connect (master, BSE_ITEM (self));
          if (!error)
            bse_item_push_undo_proc (master, "disconnect-track", self);
        }
    }
#line 273 "bsetrack.proc"
  
  g_value_set_enum (out_values++, error);
  return BSE_ERROR_NONE;
}

/* --- Export to BSE --- */
static void
__enode_insert_part__fill_strings (BseExportStrings *es)
{
  es->blurb = "Insert a part into a track and retrieve the corresponding link id.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 13;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_insert_part = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseTrack+insert-part", 
    NULL,
    "/Methods/BseTrack/General/Insert Part",
    NULL,
    __enode_insert_part__fill_strings,
  },
  0, insert_part_setup, insert_part_exec, 
};
static void
__enode_remove_tick__fill_strings (BseExportStrings *es)
{
  es->blurb = "Remove a part at specified tick from a track.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 49;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_remove_tick = {
  { (BseExportNode*) &__enode_insert_part, BSE_EXPORT_NODE_PROC,
    "BseTrack+remove-tick", 
    NULL,
    "/Methods/BseTrack/General/Remove Tick",
    NULL,
    __enode_remove_tick__fill_strings,
  },
  0, remove_tick_setup, remove_tick_exec, 
};
static void
__enode_remove_link__fill_strings (BseExportStrings *es)
{
  es->blurb = "Remove a specific part link by ID from a track.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 76;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_remove_link = {
  { (BseExportNode*) &__enode_remove_tick, BSE_EXPORT_NODE_PROC,
    "BseTrack+remove-link", 
    NULL,
    "/Methods/BseTrack/General/Remove Link",
    NULL,
    __enode_remove_link__fill_strings,
  },
  0, remove_link_setup, remove_link_exec, 
};
static void
__enode_list_parts__fill_strings (BseExportStrings *es)
{
  es->blurb = "List parts scheduled in a track, sorted by tick.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 102;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_list_parts = {
  { (BseExportNode*) &__enode_remove_link, BSE_EXPORT_NODE_PROC,
    "BseTrack+list-parts", 
    NULL,
    "/Methods/BseTrack/General/List Parts",
    NULL,
    __enode_list_parts__fill_strings,
  },
  0, list_parts_setup, list_parts_exec, 
};
static void
__enode_list_parts_uniq__fill_strings (BseExportStrings *es)
{
  es->blurb = "List all parts contained in a track.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 122;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_list_parts_uniq = {
  { (BseExportNode*) &__enode_list_parts, BSE_EXPORT_NODE_PROC,
    "BseTrack+list-parts-uniq", 
    NULL,
    "/Methods/BseTrack/General/List Parts Uniq",
    NULL,
    __enode_list_parts_uniq__fill_strings,
  },
  0, list_parts_uniq_setup, list_parts_uniq_exec, 
};
static void
__enode_get_part__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get the part starting at a specific tick position.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 151;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_get_part = {
  { (BseExportNode*) &__enode_list_parts_uniq, BSE_EXPORT_NODE_PROC,
    "BseTrack+get-part", 
    NULL,
    "/Methods/BseTrack/General/Get Part",
    NULL,
    __enode_get_part__fill_strings,
  },
  0, get_part_setup, get_part_exec, 
};
static void
__enode_get_timing__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve song timing information at a specific tick.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 176;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_get_timing = {
  { (BseExportNode*) &__enode_get_part, BSE_EXPORT_NODE_PROC,
    "BseTrack+get-timing", 
    NULL,
    "/Methods/BseTrack/General/Get Timing",
    NULL,
    __enode_get_timing__fill_strings,
  },
  0, get_timing_setup, get_timing_exec, 
};
static void
__enode_get_output_source__fill_strings (BseExportStrings *es)
{
  es->blurb = _("Get the output module for this track. The output of this module is the merged result from "
            "all polyphonic voices and has all track specific alterations applied.");
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 203;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_get_output_source = {
  { (BseExportNode*) &__enode_get_timing, BSE_EXPORT_NODE_PROC,
    "BseTrack+get-output-source", 
    NULL,
    "/Methods/BseTrack/General/Get Output Source",
    NULL,
    __enode_get_output_source__fill_strings,
  },
  0, get_output_source_setup, get_output_source_exec, 
};
static void
__enode_get_last_tick__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve the last tick for this track.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 226;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_get_last_tick = {
  { (BseExportNode*) &__enode_get_output_source, BSE_EXPORT_NODE_PROC,
    "BseTrack+get-last-tick", 
    NULL,
    "/Methods/BseTrack/General/Get Last Tick",
    NULL,
    __enode_get_last_tick__fill_strings,
  },
  0, get_last_tick_setup, get_last_tick_exec, 
};
static void
__enode_ensure_output__fill_strings (BseExportStrings *es)
{
  es->blurb = "Ensure the track has an output connection to a bus.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 245;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_ensure_output = {
  { (BseExportNode*) &__enode_get_last_tick, BSE_EXPORT_NODE_PROC,
    "BseTrack+ensure-output", 
    NULL,
    "/Methods/BseTrack/General/Ensure Output",
    NULL,
    __enode_ensure_output__fill_strings,
  },
  0, ensure_output_setup, ensure_output_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bsetrack_genprc_cc (void)
{
  return (BseExportNode*) &__enode_ensure_output;
}

/*
 * Generated data ends here
 */
